Subject: Re: [PATCH -next] usb: add usb.h stubs for CONFIG_USB not enabled

From: Greg Kroah-Hartman <[email-masked]>
Date: Sat, 19 May 2012 09:12:07 -0700

On Sat, May 19, 2012 at 08:45:44AM -0700, Randy Dunlap wrote:
> On 05/19/2012 07:16 AM, Sergei Shtylyov wrote:
> 
> > Hello.
> > 
> > On 19-05-2012 6:04, Randy Dunlap wrote:
> > 
> >> From: Randy Dunlap<[email-masked]>
> > 
> >> Add stubs for some usb core functions when CONFIG_USB
> >> is not enabled.  This fixes these comedi build errors:
> > 
> >> ERROR: "usb_deregister" [drivers/staging/comedi/comedi.ko] undefined!
> >> ERROR: "usb_register_driver" [drivers/staging/comedi/comedi.ko] undefined!
> > 
> >> Signed-off-by: Randy Dunlap<[email-masked]>
> >> ---
> >> I am only adding the stubs that are needed for comedi to build.
> >> I expect that more stubs will be needed as more build errors are
> >> found.  It seems to me that linux/usb.h might need more (major)
> >> moving of lines to support more stubs in the future.
> > 
> >>   Documentation/usb/error-codes.txt |    2 ++
> >>   include/linux/usb.h               |   24 +++++++++++++++++++++++-
> >>   2 files changed, 25 insertions(+), 1 deletion(-)
> >>
> >> --- linux-next-20120518.orig/include/linux/usb.h
> >> +++ linux-next-20120518/include/linux/usb.h
> >> @@ -10,7 +10,7 @@
> >>
> >>   #ifdef __KERNEL__
> >>
> >> -#include<linux/errno.h>         /* for -ENODEV */
> >> +#include<linux/errno.h>         /* for -ENODEV, -ENOSYS */
> >>   #include<linux/delay.h>    /* for mdelay() */
> >>   #include<linux/interrupt.h>    /* for in_interrupt() */
> >>   #include<linux/list.h>        /* for struct list_head */
> >> @@ -515,6 +515,8 @@ static inline struct usb_device *interfa
> >>       return to_usb_device(intf->dev.parent);
> >>   }
> >>
> >> +#if defined(CONFIG_USB) || defined(CONFIG_USB_MODULE)
> > 
> >    You can use IS_ENABLED(CONFIG_USB) instead of these two now.
> 
> 
> I know, but I chose not to do that in case the patch
> needs to be applied to some earlier kernels.

If it did, the person doing that would do the change :)

Please use IS_ENABLED().

thanks,

greg k-h